#include <mut321.h> 
#include <stdio.h> 
#include <genpat.h> 

char *inttostr(integer, len) 
int integer; 
int len; 
{char *str; 
str = (char *) mbkalloc (len * sizeof (char) + 1); 
sprintf (str, "%.32d", integer); 
return(&str[32-len]);
} 

void enable() 
{AFFECT(inttostr(0,32),"enable","0b1"); 
AFFECT(inttostr(88,32),"enable","0b0"); 
AFFECT(inttostr(92,32),"enable","0b1");
}

void clock() 
{int i; 
for (i=0;i < 142; i+=2) 
{AFFECT(inttostr(i,32),"clk","0b0");
AFFECT(inttostr(i+1,32),"clk","0b1");}
}

void power() 
{AFFECT(inttostr(0,32),"vdd","0b1");
AFFECT(inttostr(0,32),"vss","0b0");
AFFECT(inttostr(0,32),"vdde","0b1");
AFFECT(inttostr(0,32),"vsse","0b0");
}

void reset()
{AFFECT(inttostr(0,32),"reset","0b1");
AFFECT(inttostr(2,32),"reset","0b0");
AFFECT(inttostr(83,32),"reset","0b1");
AFFECT(inttostr(84,32),"reset","0b0");
}

void AandB()
{
AFFECT(inttostr(0,32),"A","0b1001");
AFFECT(inttostr(0,32),"B","0b0011");
AFFECT(inttostr(2,32),"A","0b0000");
AFFECT(inttostr(2,32),"B","0b0000");
AFFECT(inttostr(83,32),"A","0b0101");
AFFECT(inttostr(83,32),"B","0b0010");
AFFECT(inttostr(84,32),"A","0b0000");
AFFECT(inttostr(84,32),"B","0b0000");
}

void alarma()
{
AFFECT(inttostr(0,32),"alarm","0b1");
AFFECT(inttostr(79,32),"alarm","0b0");
AFFECT(inttostr(83,32),"alarm","0b1");
AFFECT(inttostr(137,32),"alarm","0b0");
}

int main()
{
DEF_GENPAT("time_rele");
DECLAR("vdd",":1","B",IN,"");
DECLAR("vss",":1","B",IN,"");
DECLAR("vdde",":1","B",IN,"");
DECLAR("vsse",":1","B",IN,"");
DECLAR ("clk", ":2", "B", IN, "");
DECLAR("enable",":2","B",IN,"");
DECLAR("reset",":2","B",IN,"");
DECLAR("A", ":2", "B", IN, "3 DOWNTO 0");
DECLAR("B", ":2", "B", IN, "3 DOWNTO 0");
DECLAR("alarm",":2","B",OUT,"");
power();
clock();
enable();
reset();
AandB();
alarma();
SAV_GENPAT(); 
}
