#include <genlib.h>

main ()

{

/* Merging RAM and Dath-Path blocks */
DEF_LOFIG ("core");
/* declaration of the cell's external connectors */

LOCON ("I[8:0]",IN,"i[8:0]");
LOCON ("D[15:0]",IN,"d[15:0]");
LOCON ("Y[15:0]",OUT,"y[15:0]");
LOCON ("CN",IN,"cin");
LOCON ("ZERO",OUT,"zero");
LOCON ("SIGN",OUT,"sign");
LOCON ("RAM_WE",IN,"ram_we");
LOCON ("OVR",OUT,"ovr");
LOCON ("COUT",OUT,"cout");
LOCON ("F_I0",IN,"f_i0");
LOCON ("F_I15",IN,"f_i15");
LOCON ("ACC_I0",IN,"acc_i0");
LOCON ("ACC_I15",IN,"acc_i15");
LOCON ("F_O0",OUT,"f0");
LOCON ("F_O15",OUT,"f15");
LOCON ("ACC_O0",OUT,"acc0");
LOCON ("ACC_O15",OUT,"acc15");
LOCON ("RAM_IN[15:0]",OUT,"ram_in[15:0]");
LOCON ("RAM_A[15:0]",IN,"ram_a[15:0]");
LOCON ("RAM_B[15:0]",IN,"ram_b[15:0]");
LOCON ("CLK",IN,"clk");
LOCON ("VDD",IN,"vdd");
LOCON ("VSS",IN,"vss");

LOINS ("instruction_decoder","control_inst","i[8:0]","cout15","cout14","sum15","sign","ovr","cout","n[12:0]","ram_we","clk","clk_a","clk_b","we_a","we_b","vdd","vss",0);
LOINS ("data_path","dp_inst","d[15:0]","y[15:0]","cin","cout15","cout14","zero","sum15","n[12:0]","f_i0","f_i15","acc_i0","acc_i15","f0","f15","acc0","acc15","ram_in[15:0]","ram_a[15:0]","ram_b[15:0]","clk","we_a","we_b","clk_a","clk_b","vdd", "vss", 0);

SAVE_LOFIG();

DEF_PHFIG ("core");
PLACE ("data_path","dp_inst",NOSYM, 0, 0);
PLACE ("instruction_decoder","control_inst",NOSYM, (WIDTH("data_path")-WIDTH("instruction_decoder"))/2, HEIGHT("data_path"));
DEF_AB (0, 0, 0, 0);
SAVE_PHFIG();

exit(0);
}

