#include <genlib.h>

main ()

{

/* Merging RAM and Dath-Path blocks */
DEF_LOFIG ("ram+core");
/* declaration of the cell's external connectors */

LOCON ("I[8:0]",IN,"i[8:0]");
LOCON ("D[15:0]",IN,"d[15:0]");
LOCON ("Y[15:0]",OUT,"y[15:0]");
LOCON ("CN",IN,"cin");
LOCON ("ZERO",OUT,"zero");
LOCON ("SIGN",OUT,"sign");
LOCON ("OVR",OUT,"ovr");
LOCON ("COUT",OUT,"cout");
LOCON ("F_I0",IN,"f_i0");
LOCON ("F_I15",IN,"f_i15");
LOCON ("ACC_I0",IN,"acc_i0");
LOCON ("ACC_I15",IN,"acc_i15");
LOCON ("F_O0",OUT,"f0");
LOCON ("F_O15",OUT,"f15");
LOCON ("ACC_O0",OUT,"acc0");
LOCON ("ACC_O15",OUT,"acc15");
LOCON ("CLK",IN,"clk");
LOCON ("A[7:0]",IN,"a[7:0]");
LOCON ("DATA_IN[15:0]",IN,"data_in[15:0]");
LOCON ("DATA_A[15:0]",IN,"data_a[15:0]");
LOCON ("DATA_B[15:0]",IN,"data_b[15:0]");
LOCON ("VDD",IN,"vdd");
LOCON ("VSS",IN,"vss");

LOINS ("sram","sram_inst","a[7:0]","ram_we","clk","data_in[15:0]","data_a[15:0]","data_b[15:0]","vdd","vss",0);
LOINS ("core","core_inst","i[8:0]","d[15:0]","y[15:0]","cin","zero","sign","ram_we","ovr","cout","f_i0","f_i15","acc_i0","acc_i15","f0","f15","acc0","acc15","data_in[15:0]","data_a[15:0]","data_b[15:0]","clk","vdd", "vss", 0);

SAVE_LOFIG();

DEF_PHFIG ("ram+core");
PLACE ("sram","sram_inst",NOSYM, 0, 0);
PLACE ("core","core_inst",NOSYM, (WIDTH("sram")-WIDTH("core"))/2, HEIGHT("sram"));
DEF_AB (0, 0, 0, 0);
SAVE_PHFIG();

exit(0);
}

