#include <genlib.h>

main ()

{

/* ALU with intruction decoder */
DEF_LOFIG ("sram");
/* declaration of the cell's external connectors */
LOCON ("A[7:0]",IN,"a[7:0]");
LOCON ("WE",IN,"we");
LOCON ("CLK",IN,"clk");
LOCON ("DATA_IN[15:0]",IN,"data_in[15:0]");
LOCON ("DATA_A[15:0]",OUT,"data_a[15:0]");
LOCON ("DATA_B[15:0]",OUT,"data_b[15:0]");
LOCON ("VDD",IN,"vdd");
LOCON ("VSS",IN,"vss");

LOINS ("sram_a","sram_a","a[7:0]","we","clk","vdd","data_in[15:0]","data_a[15:0]","vdd","vss",0);
LOINS ("sram_b","sram_b","a[7:0]","we","clk","vdd","data_in[15:0]","data_b[15:0]","vdd","vss",0);

SAVE_LOFIG();

DEF_PHFIG ("sram");
PLACE ("sram_a","sram_a",NOSYM, 0, 0);
PLACE ("sram_b","sram_b",NOSYM, WIDTH("sram_a"), 0);
DEF_AB (0, 0, 0, 0);
SAVE_PHFIG();

exit(0);
}

