
#include <fpgen.h>

void main()
{
    DP_DEFLOFIG( "dff_fpgen" , 16 , LSB_INDEX_ZERO );
    
    // descripcion de la interfaz
    DP_LOCON( "D[15:0]" , IN , "D[15:0]" );
    DP_LOCON( "CLK" , IN , "CLK" );
    DP_LOCON( "HAB" , IN , "HAB" );
    DP_LOCON( "Q[15:0]" , OUT , "Q[15:0]" );
    DP_LOCON( "NQ[15:0]" , OUT , "NQ[15:0]" );
    
    //POWER
    DP_LOCON( "vdd" , IN , "vdd" );
    DP_LOCON( "vss" , IN , "vss" );
   
    // implementacion
    DP_PDFF( "flipf", 16, 0, "HAB", "CLK", "D[15:0]", "Q[15:0]", 
    "NQ[15:0]", EOL );

    DP_SAVLOFIG();
}

