#include <stdio.h>
#include <genpat.h>

char *int2str(unsigned long entero)
{
	char *str;
	str = (char*) mbkalloc (32*sizeof(char));
	sprintf( str, "%lu", entero);
	return(str);
}

int main(void)
{
	int i;

	// Output file name
	DEF_GENPAT("dff_genpat");
	SETTUNIT("ns");

	// Input/Output declaration
	DECLAR("D", ":2", "X", IN, "15 DOWNTO 0","");
	DECLAR("CLK", ":2", "B", IN, "","");	
	DECLAR("HAB", ":2", "B", IN, "","");
	
	DECLAR("Q", ":2", "X", OUT, "15 DOWNTO 0","");
	DECLAR("NQ", ":2", "X", OUT, "15 DOWNTO 0","");
	
	DECLAR("vdd", ":2", "B", IN, "","");
	DECLAR("vss", ":2", "B", IN, "","");

	//Patterns
	AFFECT(int2str(0), "vdd", "0b1");
	AFFECT(int2str(0), "vss", "0b0");
	
        AFFECT(int2str(0), "D", int2str(0));
	AFFECT(int2str(0), "CLK", int2str(1));	
	AFFECT(int2str(0), "HAB", int2str(0));	


	SAV_GENPAT();
	
	exit(0);
}
