// dlatch_fpgen.c
// 2 implementacion del latch tipo D
// Junio /2000

#include <fpgen.h>

void main()
{
    // latch tipo d
    DP_DEFLOFIG( "dlatch_fpgen" , 16 , LSB_INDEX_ZERO );
    
    // descripcion de la interfaz
    DP_LOCON( "D[15:0]" , IN , "D[15:0]" );
    DP_LOCON( "CLK" , IN , "CLK" );
    DP_LOCON( "Q[15:0]" , OUT , "Q[15:0]" );
    // Aqui fue hecha la correcion: Se cambia el tipo de
    // terminal de INOUT a OUT, y se modifica el circuito.
    
    //POWER
    DP_LOCON( "vdd" , IN , "vdd" );
    DP_LOCON( "vss" , IN , "vss" );
    
    // implementacion
    DP_NAND2( "nand1", 16, 0, 2, "D[15:0]", 
    "CLK,CLK,CLK,CLK,CLK,CLK,CLK,CLK,CLK,CLK,CLK,CLK,CLK,CLK,CLK,CLK", 
    "NAND1OUT[15:0]", EOL);
    
    DP_NAND2( "nand2", 16, 0, 2, "NAND1OUT[15:0]", 
    "CLK,CLK,CLK,CLK,CLK,CLK,CLK,CLK,CLK,CLK,CLK,CLK,CLK,CLK,CLK,CLK",
    "NAND2OUT[15:0]", EOL);

    DP_NAND2( "nand3", 16, 0, 2, "NAND1OUT[15:0]", "NQ[15:0]", 
    "NAND3OUT[15:0]", EOL);

    DP_NAND2( "nand4", 16, 0, 2, "NAND1OUT[15:0]", "NQ[15:0]", 
    "Q[15:0]", EOL);
    
    
    DP_NAND2( "nand5", 16, 0, 2, "NAND3OUT[15:0]", "NAND2OUT[15:0]", 
    "NQ[15:0]", EOL);

    DP_SAVLOFIG();
}

