// sstack.c
// implementacion de la pila de instrucciones
// Abril /2000

#include <fpgen.h>

void main()
{
    // micropila
    DP_DEFLOFIG( "prueba_fpgen" , 16, LSB_INDEX_ZERO );
    
    // interfaz
    DP_LOCON( "D1[15:0]" , IN , "D1[15:0]" );
    DP_LOCON( "D2[15:0]" , IN , "D2[15:0]" );    
    DP_LOCON( "RNEN[1:0]" , IN , "RNEN[1:0]" );
    /* HERE IS THE BUG !
    DP_LOCON( "Q[15:0]" , OUT , "Q[15:0]" );    
    */
    DP_LOCON( "Q[15:0]" , TRISTATE, "Q[15:0]" );    

    //POWER
    DP_LOCON( "vdd" , IN , "vdd" );
    DP_LOCON( "vss" , IN , "vss" );
    

    DP_NBUSE( "tri1", 16, 0, "RNEN[1]", "D1[15:0]", "Q[15:0]", EOL);  
    DP_NBUSE( "tri0", 16, 0, "RNEN[0]", "D2[15:0]", "Q[15:0]", EOL);  

    DP_SAVLOFIG();
    exit(0);
}    
